package net.sf.doolin.util;

import com.google.common.base.Functions;

/**
 * Chain of two {@link ItemConverter}s.
 * 
 * @author Damien Coraboeuf
 * 
 * @param <S>
 *            Source type
 * @param <T>
 *            Intermediary type
 * @param <U>
 *            Target type
 * @deprecated Use
 *             {@link Functions#compose(com.google.common.base.Function, com.google.common.base.Function)}
 *             instead.
 */
@Deprecated
public class ChainedItemConverter<S, T, U> implements ItemConverter<S, U> {

	private final ItemConverter<S, T> firstItemConverter;
	private final ItemConverter<T, U> secondItemConverter;

	/**
	 * Constructor.
	 * 
	 * @param firstItemConverter
	 *            Conversion from S to T
	 * @param secondItemConverter
	 *            Conversion from T to U
	 */
	public ChainedItemConverter(ItemConverter<S, T> firstItemConverter,
			ItemConverter<T, U> secondItemConverter) {
		this.firstItemConverter = firstItemConverter;
		this.secondItemConverter = secondItemConverter;
	}

	@Override
	public U convert(S source) {
		T t = this.firstItemConverter.convert(source);
		return this.secondItemConverter.convert(t);
	}

}
