package net.sf.doolin.util.collection;

import java.util.Map;

import com.google.common.base.Predicate;

/**
 * Predicate based on the presence of the evaluated object in the keys of a map.
 * 
 * @author Damien Coraboeuf
 * 
 * @param <E>
 *            Type of element
 */
public class MapPredicate<E> implements Predicate<E> {

	private final Map<E, ?> map;

	/**
	 * Constructor
	 * 
	 * @param map
	 *            Map to check the elements against
	 */
	public MapPredicate(Map<E, ?> map) {
		this.map = map;
	}

	@Override
	public boolean apply(E e) {
		return this.map.containsKey(e);
	}

}
