/**
 * 
 */
package net.sf.doolin.util.expression;

/**
 * Utility ancestor for the {@link Token} classes.
 * 
 * @author Damien Coraboeuf
 * 
 */
public abstract class AbstractToken implements Token {

	private TokenType type;

	private boolean close;

	/**
	 * Constructor.
	 * 
	 * @param type
	 *            Type of token.
	 */
	public AbstractToken(TokenType type) {
		this.type = type;
	}

	public void close() {
		close = true;
	}

	public boolean isClosed() {
		return close;
	}

	@Override
	public TokenType getType() {
		return type;
	}

}