package net.sf.doolin.util.factory;

import net.sf.doolin.util.Utils;

/**
 * Just instantiates a bean given its class.
 * 
 * @param <T>
 *            Type of the bean to create.
 * 
 * @author Damien Coraboeuf
 */
public class SimpleDataFactory<T> implements DataFactory<T> {

	private Class<T> beanClass;

	/**
	 * Default constructor
	 */
	public SimpleDataFactory() {
	}

	/**
	 * Instantiates a new simple data factory.
	 * 
	 * @param beanClass
	 *            the bean class
	 */
	public SimpleDataFactory(Class<T> beanClass) {
		this.beanClass = beanClass;
	}

	/**
	 * @see Utils#newInstance(Class)
	 */
	@Override
	public T create(Object any) {
		return Utils.newInstance(this.beanClass);
	}

	/**
	 * Sets the class to create
	 * 
	 * @param beanClass
	 *            Class
	 */
	public void setBeanClass(Class<T> beanClass) {
		this.beanClass = beanClass;
	}

}
